#ifndef _CALCULATOR_
#define _CALCULATOR_

#include "queue.h"

#ifndef TRUE
	#define TRUE 1
#endif
#ifndef FALSE
	#define FALSE 0
#endif

typedef enum{
	LEFT_BRACKET=1,
	RIGHT_BRACKET=2,
	PLUS=3,
	MINUS=4,
	TIMES=5,
	DIVIDE=6,
	POWER=7,
	UNARY_MINUS=8
} operators;

typedef enum{
	OPERATOR,
	OPERAND
} ItemType;

typedef struct{
	ItemType Type;
	long Val;
} Item;

int readInput(char* input, Queue* infixQueue);
void enqueueOperator(Queue*, operators);
void transform(Queue* infixQueue, Queue* postfixQueue);
int calculate(Queue* postfixQueue, long* result);
int evaluate(char* input, long* result);

#endif
