#ifndef _QUEUE_
#define _QUEUE_

#ifndef NULL
	#define NULL 0
#endif

struct Element{
	void* data;
	struct Element *next;
	struct Element *prev;
};

typedef struct {
	struct Element *head;
	struct Element *tail;
	int length;
} Queue;

Queue* queueNew(void);

void queueDestroy(Queue* queue);

int queueGetLength(Queue* queue);

void queuePushHead(Queue* queue, void* val);

void queuePushTail(Queue* queue, void* val);

void* queuePopHead(Queue* queue);

void* queuePopTail(Queue* queue);

#endif
